/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.159 Revision 1.231
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.159 2006/02/17 22:18:20 swegener Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.231 2010/04/26 08:05:10 robbat2 Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Maintainer: kernel-misc@gentoo.org
9# 10#
10# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
11 12
12# added functionality: 13# added functionality:
13# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
21# EXTRAVERSION would be something like : -wolk-4.19-r1 22# EXTRAVERSION would be something like : -wolk-4.19-r1
22# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
23# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
24# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
25# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
26# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
27# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
28# the patchset version for 31# the patchset version for
29# and not use it as a true package revision 32# and not use it as a true package revision
30# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
31# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
32# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
33# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
34# K_SYMLINK - if this is set, then forcably create symlink anyway 38# K_SYMLINK - if this is set, then forcably create symlink anyway
35# 39#
36# K_DEFCONFIG - Allow specifying a different defconfig target. 40# K_DEFCONFIG - Allow specifying a different defconfig target.
37# If length zero, defaults to "defconfig". 41# If length zero, defaults to "defconfig".
38# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any 42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
39# combination of "base" and "extras" 43# combination of "base" and "extras"
40# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply. 44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
41# A value of "5" would apply genpatches-2.6.12-5 to 45# A value of "5" would apply genpatches-2.6.12-5 to
42# my-sources-2.6.12.ebuild 46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
48# K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
49# code. If empty, will be set to "1" if deblobbing is
50# possible. Test ONLY for "1".
51# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
52# If false, either optional deblobbing will be available
53# or the license will note the inclusion of freedist
54# code.
43 55
44# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 56# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
45# can be supported by the headers ebuild 57# can be supported by the headers ebuild
46 58
47# UNIPATCH_LIST - space delimetered list of patches to be applied to the 59# UNIPATCH_LIST - space delimetered list of patches to be applied to the
53# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 65# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
54# the doc dir 66# the doc dir
55# UNIPATCH_STRICTORDER - if this is set places patches into directories of 67# UNIPATCH_STRICTORDER - if this is set places patches into directories of
56# order, so they are applied in the order passed 68# order, so they are applied in the order passed
57 69
58inherit toolchain-funcs versionator multilib 70inherit eutils toolchain-funcs versionator multilib
59EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install \ 71EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst
60 pkg_preinst pkg_postinst
61 72
62# Added by Daniel Ostrow <dostrow@gentoo.org> 73# Added by Daniel Ostrow <dostrow@gentoo.org>
63# This is an ugly hack to get around an issue with a 32-bit userland on ppc64. 74# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
64# I will remove it when I come up with something more reasonable. 75# I will remove it when I come up with something more reasonable.
65[[ ${PROFILE_ARCH} == 'ppc64' ]] && CHOST='powerpc64-unknown-linux-gnu' 76[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
66 77
67export CTARGET=${CTARGET:-${CHOST}} 78export CTARGET=${CTARGET:-${CHOST}}
68if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 79if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
69 export CTARGET=${CATEGORY/cross-} 80 export CTARGET=${CATEGORY/cross-}
70fi 81fi
71 82
72HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 83HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
84[[ -z ${LICENSE} ]] && \
73LICENSE="GPL-2" 85 LICENSE="GPL-2"
86
87# This is the latest KV_PATCH of the deblob tool available from the
88# libre-sources upstream.
89[[ -z ${DEBLOB_MAX_VERSION} ]] && DEBLOB_MAX_VERSION=33
90
91# No need to run scanelf/strip on kernel sources/headers (bug #134453).
92RESTRICT="binchecks strip"
74 93
75# set LINUX_HOSTCFLAGS if not already set 94# set LINUX_HOSTCFLAGS if not already set
76[[ -z ${LINUX_HOSTCFLAGS} ]] && \ 95[[ -z ${LINUX_HOSTCFLAGS} ]] && \
77 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 96 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
97
98# debugging functions
99#==============================================================
100# this function exists only to help debug kernel-2.eclass
101# if you are adding new functionality in, put a call to it
102# at the start of src_unpack, or during SRC_URI/dep generation.
103debug-print-kernel2-variables() {
104 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
105 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
106 UNIPATCH_LIST S KERNEL_URI ; do
107 debug-print "${v}: ${!v}"
108 done
109}
78 110
79#Eclass functions only from here onwards ... 111#Eclass functions only from here onwards ...
80#============================================================== 112#==============================================================
81handle_genpatches() { 113handle_genpatches() {
82 local tarball 114 local tarball
83 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return -1 115 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
84 116
85 for i in ${K_WANT_GENPATCHES} ; do 117 for i in ${K_WANT_GENPATCHES} ; do
86 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2" 118 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
87 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}" 119 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
88 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}" 120 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
139 # Now we know that RELEASE is the -rc/-git 171 # Now we know that RELEASE is the -rc/-git
140 # and RELEASETYPE is the same but with its numerics stripped 172 # and RELEASETYPE is the same but with its numerics stripped
141 # we can work on better sorting EXTRAVERSION. 173 # we can work on better sorting EXTRAVERSION.
142 # first of all, we add the release 174 # first of all, we add the release
143 EXTRAVERSION="${RELEASE}" 175 EXTRAVERSION="${RELEASE}"
176 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
144 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}" 177 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
145 178
179 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
180 if [[ -n "${K_NOUSEPR}" ]]; then
181 # Don't add anything based on PR to EXTRAVERSION
182 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
146 if [[ -n ${K_PREPATCHED} ]]; then 183 elif [[ -n ${K_PREPATCHED} ]]; then
184 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
147 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}" 185 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
148 elif [[ "${ETYPE}" = "sources" ]]; then 186 elif [[ "${ETYPE}" = "sources" ]]; then
187 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
149 # For some sources we want to use the PV in the extra version 188 # For some sources we want to use the PV in the extra version
150 # This is because upstream releases with a completely different 189 # This is because upstream releases with a completely different
151 # versioning scheme. 190 # versioning scheme.
152 case ${PN/-*} in 191 case ${PN/-*} in
153 wolk) K_USEPV=1;; 192 wolk) K_USEPV=1;;
154 vserver) K_USEPV=1;; 193 vserver) K_USEPV=1;;
155 esac 194 esac
156 195
157 [[ -z ${K_NOUSENAME} ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}" 196 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
158 [[ -n ${K_USEPV} ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}" 197 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
159 [[ -n ${PR//r0} ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 198 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
160 fi 199 fi
200 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
161 201
162 # The only messing around which should actually effect this is for KV_EXTRA 202 # The only messing around which should actually effect this is for KV_EXTRA
163 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else 203 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
164 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION 204 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
165 if [[ -n ${KV_EXTRA} ]]; then 205 if [[ -n ${KV_EXTRA} ]]; then
202 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 242 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
203 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 243 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
204 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2" 244 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
205 fi 245 fi
206 246
247 debug-print-kernel2-variables
248
207 handle_genpatches 249 handle_genpatches
208} 250}
209 251
210kernel_is() { 252kernel_is() {
253 # ALL of these should be set before we can safely continue this function.
254 # some of the sources have in the past had only one set.
255 local v n=0
256 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
211 [[ -z ${OKV} ]] && detect_version 257 [[ $n -eq 1 ]] && detect_version
258 unset v n
259
260 # Now we can continue
212 local operator test value x=0 y=0 z=0 261 local operator test value x=0 y=0 z=0
213 262
214 case ${1} in 263 case ${1} in
215 lt) operator="-lt"; shift;; 264 lt) operator="-lt"; shift;;
216 gt) operator="-gt"; shift;; 265 gt) operator="-gt"; shift;;
248} 297}
249 298
250# Capture the sources type and set DEPENDs 299# Capture the sources type and set DEPENDs
251if [[ ${ETYPE} == sources ]]; then 300if [[ ${ETYPE} == sources ]]; then
252 DEPEND="!build? ( sys-apps/sed 301 DEPEND="!build? ( sys-apps/sed
253 >=sys-devel/binutils-2.11.90.0.31 ) 302 >=sys-devel/binutils-2.11.90.0.31 )"
254 doc? ( app-text/docbook-sgml-utils
255 app-text/xmlto )"
256 RDEPEND="!build? ( >=sys-libs/ncurses-5.2 303 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
257 sys-devel/make ) 304 sys-devel/make )"
258 virtual/dev-manager" 305 PDEPEND="!build? ( virtual/dev-manager )"
259 306
260 PROVIDE="virtual/linux-sources" 307 PROVIDE="virtual/linux-sources"
261 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa" 308 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
262 309
263 SLOT="${PVR}" 310 SLOT="${PVR}"
264 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel" 311 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel"
265 IUSE="symlink build doc" 312 IUSE="symlink build"
313
314 # Bug #266157, deblob for libre support
315 if [[ -z ${K_PREDEBLOBBED} ]] ; then
316 if [[ -z ${K_DEBLOB_AVAILABLE} ]] ; then
317 kernel_is ge 2 6 27 && \
318 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
319 K_DEBLOB_AVAILABLE=1
320 fi
321 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
322 IUSE="${IUSE} deblob"
323 # Reflect that kernels contain firmware blobs unless otherwise
324 # stripped
325 LICENSE="${LICENSE} !deblob? ( freedist )"
326
327 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
328 DEBLOB_A="deblob-${DEBLOB_PV}"
329 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
330 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
331
332 KERNEL_URI="${KERNEL_URI}
333 deblob? (
334 ${DEBLOB_HOMEPAGE}/download/releases/LATEST-${DEBLOB_PV}.N/${DEBLOB_A}
335 )"
336 else
337 # We have no way to deblob older kernels, so just mark them as
338 # tainted with non-libre materials.
339 LICENSE="${LICENSE} freedist"
340 fi
341 fi
342
266elif [[ ${ETYPE} == headers ]]; then 343elif [[ ${ETYPE} == headers ]]; then
267 DESCRIPTION="Linux system headers" 344 DESCRIPTION="Linux system headers"
268 IUSE="" 345
346 # Since we should NOT honour KBUILD_OUTPUT in headers
347 # lets unset it here.
348 unset KBUILD_OUTPUT
269 349
270 if [[ ${CTARGET} = ${CHOST} ]]; then 350 if [[ ${CTARGET} = ${CHOST} ]]; then
271 DEPEND="!virtual/os-headers" 351 DEPEND="!virtual/os-headers"
272 PROVIDE="virtual/os-headers" 352 PROVIDE="virtual/os-headers"
273 SLOT="0" 353 SLOT="0"
282# Cross-compile support functions 362# Cross-compile support functions
283#============================================================== 363#==============================================================
284kernel_header_destdir() { 364kernel_header_destdir() {
285 [[ ${CTARGET} == ${CHOST} ]] \ 365 [[ ${CTARGET} == ${CHOST} ]] \
286 && echo /usr/include \ 366 && echo /usr/include \
287 || echo /usr/${CTARGET}/include 367 || echo /usr/${CTARGET}/usr/include
288} 368}
289 369
290cross_pre_c_headers() { 370cross_pre_c_headers() {
291 [[ -z ${_E_CROSS_HEADERS_ONLY} ]] && return 1 371 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
292 [[ ${CHOST} == ${CTARGET} ]] && return 1
293 return 0
294} 372}
295 373
296env_setup_xmakeopts() { 374env_setup_xmakeopts() {
297 # Kernel ARCH != portage ARCH 375 # Kernel ARCH != portage ARCH
298 export KARCH=$(tc-arch-kernel) 376 export KARCH=$(tc-arch-kernel)
309} 387}
310 388
311# Unpack functions 389# Unpack functions
312#============================================================== 390#==============================================================
313unpack_2_4() { 391unpack_2_4() {
314 env_setup_xmakeopts
315
316 cd "${S}"
317 # this file is required for other things to build properly, 392 # this file is required for other things to build properly,
318 # so we autogenerate it 393 # so we autogenerate it
319 make -s mrproper ${xmakeopts} || die "make mrproper failed" 394 make -s mrproper ${xmakeopts} || die "make mrproper failed"
320 make -s symlinks ${xmakeopts} || die "make symlinks failed" 395 make -s symlinks ${xmakeopts} || die "make symlinks failed"
321 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed" 396 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
322 echo ">>> version.h compiled successfully." 397 echo ">>> version.h compiled successfully."
323} 398}
324 399
325unpack_2_6() { 400unpack_2_6() {
326 env_setup_xmakeopts
327
328 cd "${S}"
329 # this file is required for other things to build properly, so we 401 # this file is required for other things to build properly, so we
330 # autogenerate it ... touch .config to keep version.h build from 402 # autogenerate it ... generate a .config to keep version.h build from
331 # spitting out an annoying warning 403 # spitting out an annoying warning
332 make -s mrproper ${xmakeopts} || die "make mrproper failed" 404 make -s mrproper ${xmakeopts} 2>/dev/null \
405 || die "make mrproper failed"
406
407 # quick fix for bug #132152 which triggers when it cannot include linux
408 # headers (ie, we have not installed it yet)
409 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
333 touch .config 410 touch .config
334 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed" 411 eerror "make defconfig failed."
335 rm -f .config 412 eerror "assuming you dont have any headers installed yet and continuing"
413 epause 5
414 fi
415
416 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
417 || die "make include/linux/version.h failed"
418 rm -f .config >/dev/null
336} 419}
337 420
338universal_unpack() { 421universal_unpack() {
339 cd ${WORKDIR} 422 cd "${WORKDIR}"
340 unpack linux-${OKV}.tar.bz2 423 unpack linux-${OKV}.tar.bz2
424 if [[ -d "linux" ]]; then
425 mv linux linux-${KV_FULL} \
426 || die "Unable to move source tree to ${KV_FULL}."
341 if [[ "${OKV}" != "${KV_FULL}" ]]; then 427 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
342 mv linux-${OKV} linux-${KV_FULL} \ 428 mv linux-${OKV} linux-${KV_FULL} \
343 || die "Unable to move source tree to ${KV_FULL}." 429 || die "Unable to move source tree to ${KV_FULL}."
344 fi 430 fi
345 cd "${S}" 431 cd "${S}"
346 432
347 # remove all backup files 433 # remove all backup files
348 find . -iname "*~" -exec rm {} \; 2> /dev/null 434 find . -iname "*~" -exec rm {} \; 2> /dev/null
349 435
350 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox 436 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
351 use ppc && \ 437 # only do this for kernel < 2.6.27 since this file does not exist in later
438 # kernels
439 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
440 then
441 sed -i \
352 sed -ie 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \ 442 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
353 "${S}"/arch/ppc/Makefile 443 "${S}"/arch/ppc/Makefile
444 else
445 sed -i \
446 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
447 "${S}"/arch/powerpc/Makefile
448 fi
354} 449}
355 450
356unpack_set_extraversion() { 451unpack_set_extraversion() {
357 cd "${S}" 452 cd "${S}"
358 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 453 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
359 cd ${OLDPWD} 454 cd "${OLDPWD}"
360} 455}
361 456
362# Should be done after patches have been applied 457# Should be done after patches have been applied
363# Otherwise patches that modify the same area of Makefile will fail 458# Otherwise patches that modify the same area of Makefile will fail
364unpack_fix_install_path() { 459unpack_fix_install_path() {
365 cd "${S}" 460 cd "${S}"
366 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile 461 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
367} 462}
368 463
369unpack_fix_docbook() {
370 if [[ -d ${S}/Documentation/DocBook ]]; then
371 cd "${S}"/Documentation/DocBook
372 sed -ie "s:db2:docbook2:g" Makefile
373 cd ${OLDPWD}
374 fi
375}
376
377# Compile Functions 464# Compile Functions
378#============================================================== 465#==============================================================
379compile_headers() { 466compile_headers() {
380 env_setup_xmakeopts 467 env_setup_xmakeopts
381
382 # Since KBUILD_OUTPUT shouldnt be used when compiling headers, lets unset it
383 # if it exists.
384 [[ -n ${KBUILD_OUTPUT} ]] && unset KBUILD_OUTPUT
385 468
386 # if we couldnt obtain HOSTCFLAGS from the Makefile, 469 # if we couldnt obtain HOSTCFLAGS from the Makefile,
387 # then set it to something sane 470 # then set it to something sane
388 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile) 471 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
389 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer} 472 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
391 if kernel_is 2 4; then 474 if kernel_is 2 4; then
392 yes "" | make oldconfig ${xmakeopts} 475 yes "" | make oldconfig ${xmakeopts}
393 echo ">>> make oldconfig complete" 476 echo ">>> make oldconfig complete"
394 make dep ${xmakeopts} 477 make dep ${xmakeopts}
395 elif kernel_is 2 6; then 478 elif kernel_is 2 6; then
479 # 2.6.18 introduces headers_install which means we dont need any
480 # of this crap anymore :D
481 kernel_is ge 2 6 18 && return 0
482
396 # autoconf.h isnt generated unless it already exists. plus, we have 483 # autoconf.h isnt generated unless it already exists. plus, we have
397 # no guarantee that any headers are installed on the system... 484 # no guarantee that any headers are installed on the system...
398 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \ 485 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
399 || touch include/linux/autoconf.h 486 || touch include/linux/autoconf.h
400 487
401 # if K_DEFCONFIG isn't set, force to "defconfig" 488 # if K_DEFCONFIG isn't set, force to "defconfig"
402 # needed by mips 489 # needed by mips
403 if [[ -z ${K_DEFCONFIG} ]]; then 490 if [[ -z ${K_DEFCONFIG} ]]; then
491 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
492 case ${CTARGET} in
493 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
494 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
495 *) K_DEFCONFIG="defconfig";;
496 esac
497 else
404 K_DEFCONFIG="defconfig" 498 K_DEFCONFIG="defconfig"
499 fi
405 fi 500 fi
406 501
407 # if there arent any installed headers, then there also isnt an asm 502 # if there arent any installed headers, then there also isnt an asm
408 # symlink in /usr/include/, and make defconfig will fail, so we have 503 # symlink in /usr/include/, and make defconfig will fail, so we have
409 # to force an include path with $S. 504 # to force an include path with $S.
410 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/" 505 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
411 ln -sf asm-${KARCH} "${S}"/include/asm 506 ln -sf asm-${KARCH} "${S}"/include/asm
412 cross_pre_c_headers && return 0 507 cross_pre_c_headers && return 0
413 508
414 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed" 509 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
510 if compile_headers_tweak_config ; then
511 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
512 fi
415 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 513 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
416 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 514 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
417 fi 515 fi
418} 516}
419 517
420compile_manpages() { 518compile_headers_tweak_config() {
421 einfo "Making manpages ..." 519 # some targets can be very very picky, so let's finesse the
422 env -u ARCH make mandocs 520 # .config based upon any info we may have
521 case ${CTARGET} in
522 sh*)
523 sed -i '/CONFIG_CPU_SH/d' .config
524 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
525 return 0;;
526 esac
527
528 # no changes, so lets do nothing
529 return 1
423} 530}
424 531
425# install functions 532# install functions
426#============================================================== 533#==============================================================
427install_universal() { 534install_universal() {
428 #fix silly permissions in tarball 535 #fix silly permissions in tarball
429 cd ${WORKDIR} 536 cd "${WORKDIR}"
430 chown -R root:root * 537 chown -R root:0 * >& /dev/null
431 chmod -R a+r-w+X,u+w * 538 chmod -R a+r-w+X,u+w *
432 cd ${OLDPWD} 539 cd ${OLDPWD}
433} 540}
434 541
435install_headers() { 542install_headers() {
436 local ddir=$(kernel_header_destdir) 543 local ddir=$(kernel_header_destdir)
437 544
545 # 2.6.18 introduces headers_install which means we dont need any
546 # of this crap anymore :D
547 if kernel_is ge 2 6 18 ; then
548 env_setup_xmakeopts
549 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
550
551 # let other packages install some of these headers
552 rm -rf "${D}"/${ddir}/sound #alsa-headers
553 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
554 return 0
555 fi
556
557 # Do not use "linux/*" as that can cause problems with very long
558 # $S values where the cmdline to cp is too long
438 cd "${S}" 559 cd "${S}"
439 dodir ${ddir}/linux 560 dodir ${ddir}/linux
440 cp -ax "${S}"/include/linux/* ${D}/${ddir}/linux 561 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
441 rm -rf ${D}/${ddir}/linux/modules 562 rm -rf "${D}"/${ddir}/linux/modules
442 563
443 # Handle multilib headers and crap 564 # Handle multilib headers and crap
444 local multi_dirs="" multi_defs="" 565 local multi_dirs="" multi_defs=""
445 case $(tc-arch-kernel) in 566 case $(tc-arch-kernel) in
446 sparc64) 567 sparc64)
459 multi_dirs="s390 s390x" 580 multi_dirs="s390 s390x"
460 multi_defs="!__s390x__ __s390x__" 581 multi_defs="!__s390x__ __s390x__"
461 ;; 582 ;;
462 arm) 583 arm)
463 dodir ${ddir}/asm 584 dodir ${ddir}/asm
464 cp -ax "${S}"/include/asm/* "${D}"/${ddir}/asm 585 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
465 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch 586 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
466 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc 587 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
467 ;; 588 ;;
468 powerpc) 589 powerpc)
469 dodir ${ddir}/asm 590 dodir ${ddir}/asm
470 cp -ax "${S}"/include/asm/* ${D}/${ddir}/asm 591 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
471 if [[ -e "${S}"/include/asm-ppc ]] ; then 592 if [[ -e "${S}"/include/asm-ppc ]] ; then
472 dodir ${ddir}/asm-ppc 593 dodir ${ddir}/asm-ppc
473 cp -ax "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc 594 cp -pPR "${S}"/include/asm-ppc/* "${D}"/${ddir}/asm-ppc
474 fi 595 fi
475 ;; 596 ;;
476 *) 597 *)
477 dodir ${ddir}/asm 598 dodir ${ddir}/asm
478 cp -ax "${S}"/include/asm/* ${D}/${ddir}/asm 599 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
479 ;; 600 ;;
480 esac 601 esac
481 if [[ -n ${multi_dirs} ]] ; then 602 if [[ -n ${multi_dirs} ]] ; then
482 local d ml_inc="" 603 local d ml_inc=""
483 for d in ${multi_dirs} ; do 604 for d in ${multi_dirs} ; do
484 dodir ${ddir}/asm-${d} 605 dodir ${ddir}/asm-${d}
485 cp -ax "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed" 606 cp -pPR "${S}"/include/asm-${d}/* "${D}"/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
486 607
487 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}" 608 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
488 multi_defs=${multi_defs#* } 609 multi_defs=${multi_defs#* }
489 done 610 done
490 create_ml_includes ${ddir}/asm ${ml_inc} 611 create_ml_includes ${ddir}/asm ${ml_inc}
491 fi 612 fi
492 613
493 if kernel_is 2 6; then 614 if kernel_is 2 6; then
494 dodir ${ddir}/asm-generic 615 dodir ${ddir}/asm-generic
495 cp -ax "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic 616 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
496 fi 617 fi
497 618
498 # clean up 619 # clean up
499 find "${D}" -name '*.orig' -exec rm -f {} \; 620 find "${D}" -name '*.orig' -exec rm -f {} \;
500 621
501 cd ${OLDPWD} 622 cd ${OLDPWD}
502} 623}
503 624
504install_sources() { 625install_sources() {
505 local doc docs file 626 local file
506 627
507 cd "${S}" 628 cd "${S}"
508 dodir /usr/src 629 dodir /usr/src
509 echo ">>> Copying sources ..." 630 echo ">>> Copying sources ..."
510 631
524 [[ -f ${FILESDIR}/../ChangeLog ]] && \ 645 [[ -f ${FILESDIR}/../ChangeLog ]] && \
525 echo "Please check the ebuild ChangeLog for more details." \ 646 echo "Please check the ebuild ChangeLog for more details." \
526 > "${S}"/patches.txt 647 > "${S}"/patches.txt
527 fi 648 fi
528 649
529 if use doc ; then
530 install_manpages
531
532 for doc in ${UNIPATCH_DOCS}; do [[ -f ${doc} ]] && docs="${docs} ${doc}"; done
533 if [[ -f ${S}/patches.txt ]]; then docs="${docs} ${S}/patches.txt"; fi
534 [[ -n ${docs} ]] && dodoc ${docs}
535 fi
536
537 mv ${WORKDIR}/linux* ${D}/usr/src 650 mv ${WORKDIR}/linux* "${D}"/usr/src
538}
539
540install_manpages() {
541 kernel_is lt 2 5 && return
542
543 local myfiles="Documentation/DocBook/Makefile"
544 kernel_is lt 2 6 12 && myfiles="scripts/makeman ${myfiles}"
545
546 sed -ie "s#/usr/local/man#${D}/usr/share/man#g" ${myfiles}
547 ebegin "Installing manpages"
548 env -u ARCH make installmandocs
549 eend $?
550 sed -ie "s#${D}/usr/share/man#/usr/local/man#g" ${myfiles}
551} 651}
552 652
553# pkg_preinst functions 653# pkg_preinst functions
554#============================================================== 654#==============================================================
555preinst_headers() { 655preinst_headers() {
564 local MAKELINK=0 664 local MAKELINK=0
565 665
566 # if we have USE=symlink, then force K_SYMLINK=1 666 # if we have USE=symlink, then force K_SYMLINK=1
567 use symlink && K_SYMLINK=1 667 use symlink && K_SYMLINK=1
568 668
669 # if we're using a deblobbed kernel, it's not supported
670 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
671 use deblob && \
672 K_SECURITY_UNSUPPORTED=1
673
569 # if we are to forcably symlink, delete it if it already exists first. 674 # if we are to forcably symlink, delete it if it already exists first.
570 if [[ -n ${K_SYMLINK} ]]; then 675 if [[ ${K_SYMLINK} > 0 ]]; then
571 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux 676 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
572 MAKELINK=1 677 MAKELINK=1
573 fi 678 fi
574 679
575 # if the link doesnt exist, lets create it 680 # if the link doesnt exist, lets create it
576 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1 681 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
577 682
578 if [[ ${MAKELINK} == 1 ]]; then 683 if [[ ${MAKELINK} == 1 ]]; then
579 cd ${ROOT}usr/src 684 cd "${ROOT}"usr/src
580 ln -sf linux-${KV_FULL} linux 685 ln -sf linux-${KV_FULL} linux
581 cd ${OLDPWD} 686 cd ${OLDPWD}
582 fi 687 fi
583 688
584 # Don't forget to make directory for sysfs 689 # Don't forget to make directory for sysfs
585 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys 690 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
586 691
587 echo 692 echo
588 einfo "After installing a new kernel of any version, it is important"
589 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
590 einfo "created (X.Y is the first 2 parts of your new kernel version)"
591 echo
592 einfo "For example, this kernel will require:"
593 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
594 echo
595 einfo "If you are upgrading from a previous kernel, you may be interested" 693 elog "If you are upgrading from a previous kernel, you may be interested"
596 einfo "in the following documents:" 694 elog "in the following document:"
597 einfo " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml" 695 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
598 kernel_is_2_6 && einfo " - 2.4 to 2.6 migration guide: http://www.gentoo.org/doc/en/migration-to-2.6.xml"
599 if kernel_is ge 2 6 13; then
600 ewarn "As of 2.6.13 the support for devfs has been removed."
601 ewarn "You will be required to either manage a static /dev"
602 ewarn "or to ensure that udev is starting on boot."
603 fi
604 echo 696 echo
605 697
606 # if K_EXTRAEINFO is set then lets display it now 698 # if K_EXTRAEINFO is set then lets display it now
607 if [[ -n ${K_EXTRAEINFO} ]]; then 699 if [[ -n ${K_EXTRAEINFO} ]]; then
608 echo ${K_EXTRAEINFO} | fmt | 700 echo ${K_EXTRAEINFO} | fmt |
609 while read -s ELINE; do einfo "${ELINE}"; done 701 while read -s ELINE; do einfo "${ELINE}"; done
610 fi 702 fi
611 703
704 # if K_EXTRAELOG is set then lets display it now
705 if [[ -n ${K_EXTRAELOG} ]]; then
706 echo ${K_EXTRAELOG} | fmt |
707 while read -s ELINE; do elog "${ELINE}"; done
708 fi
709
612 # if K_EXTRAEWARN is set then lets display it now 710 # if K_EXTRAEWARN is set then lets display it now
613 if [[ -n ${K_EXTRAEWARN} ]]; then 711 if [[ -n ${K_EXTRAEWARN} ]]; then
614 echo ${K_EXTRAEWARN} | fmt | 712 echo ${K_EXTRAEWARN} | fmt |
615 while read -s ELINE; do ewarn "${ELINE}"; done 713 while read -s ELINE; do ewarn "${ELINE}"; done
616 fi 714 fi
715
716 # optionally display security unsupported message
717 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
718 echo
719 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
720 ewarn "This means that it is likely to be vulnerable to recent security issues."
721 ewarn "For specific information on why this kernel is unsupported, please read:"
722 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
723 fi
724
725 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
726 KV_MAJOR=$(get_version_component_range 1 ${OKV})
727 KV_MINOR=$(get_version_component_range 2 ${OKV})
728 KV_PATCH=$(get_version_component_range 3 ${OKV})
729 if [[ "$(tc-arch)" = "sparc" ]] \
730 && [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
731 then
732 echo
733 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
734 elog "you now need to do"
735 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
736 elog "instead of just"
737 elog " make"
738 elog "to compile the kernel. For more information please browse to"
739 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
740 echo
741 fi
617} 742}
618 743
619postinst_headers() { 744postinst_headers() {
620 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation" 745 elog "Kernel headers are usually only used when recompiling your system libc, as"
621 einfo "of newer headers, it is advised that you re-merge glibc as follows:" 746 elog "such, following the installation of newer headers, it is advised that you"
622 einfo "emerge glibc" 747 elog "re-merge your system libc."
623 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel" 748 elog "Failure to do so will cause your system libc to not make use of newer"
624 einfo "headers." 749 elog "features present in the updated kernel headers."
625} 750}
626 751
627# pkg_setup functions 752# pkg_setup functions
628#============================================================== 753#==============================================================
629setup_headers() { 754setup_headers() {
643 768
644# unipatch 769# unipatch
645#============================================================== 770#==============================================================
646unipatch() { 771unipatch() {
647 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE 772 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
648 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG 773 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG extglob_bak
649 774
650 # set to a standard locale to ensure sorts are ordered properly. 775 # set to a standard locale to ensure sorts are ordered properly.
651 myLC_ALL="${LC_ALL}" 776 myLC_ALL="${LC_ALL}"
652 myLANG="${LANG}" 777 myLANG="${LANG}"
653 LC_ALL="C" 778 LC_ALL="C"
655 780
656 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 781 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
657 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 782 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
658 783
659 # We're gonna need it when doing patches with a predefined patchlevel 784 # We're gonna need it when doing patches with a predefined patchlevel
785 extglob_bak=$(shopt -p extglob)
660 shopt -s extglob 786 shopt -s extglob
661 787
662 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 788 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
663 # usage can be either via an env var or by params 789 # usage can be either via an env var or by params
664 # although due to the nature we pass this within this eclass 790 # although due to the nature we pass this within this eclass
666 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 792 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
667 UNIPATCH_LIST="${@}" 793 UNIPATCH_LIST="${@}"
668 794
669 #unpack any passed tarballs 795 #unpack any passed tarballs
670 for i in ${UNIPATCH_LIST}; do 796 for i in ${UNIPATCH_LIST}; do
671 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then 797 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
672 extention=${i/*./}
673 extention=${extention/:*/}
674 case ${extention} in
675 tbz2) PIPE_CMD="tar -xvjf";;
676 bz2) PIPE_CMD="tar -xvjf";;
677 tgz) PIPE_CMD="tar -xvzf";;
678 gz) PIPE_CMD="tar -xvzf";;
679 *) eerror "Unrecognized tarball compression"
680 die "Unrecognized tarball compression";;
681 esac
682
683 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 798 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
684 unset z 799 unset z
685 STRICT_COUNT=$((10#${STRICT_COUNT} + 1)) 800 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
686 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++)); 801 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
687 do z="${z}0"; 802 do z="${z}0";
688 done 803 done
689 PATCH_ORDER="${z}${STRICT_COUNT}" 804 PATCH_ORDER="${z}${STRICT_COUNT}"
690 805
691 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 806 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
692 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${PATCH_ORDER}/ 1>/dev/null 807 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
808 unpack ${i##*/}
809 popd >/dev/null
693 else 810 else
694 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 811 pushd "${KPATCH_DIR}" >/dev/null
812 unpack ${i##*/}
813 popd >/dev/null
695 fi 814 fi
696 815
697 if [ $? == 0 ]; then
698 einfo "${i/*\//} unpacked"
699 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets" 816 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
700 else
701 eerror "Failed to unpack ${i/:*/}"
702 die "unable to unpack patch tarball"
703 fi
704 else 817 else
705 extention=${i/*./} 818 extention=${i/*./}
706 extention=${extention/:*/} 819 extention=${extention/:*/}
707 PIPE_CMD="" 820 PIPE_CMD=""
708 case ${extention} in 821 case ${extention} in
751 KPATCH_DIR="" 864 KPATCH_DIR=""
752 for i in $(find ${x} -type d | sort -n); do 865 for i in $(find ${x} -type d | sort -n); do
753 KPATCH_DIR="${KPATCH_DIR} ${i}" 866 KPATCH_DIR="${KPATCH_DIR} ${i}"
754 done 867 done
755 868
869 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
870 # bug #272676
871 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
872 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
873 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
874 echo
875 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
876 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
877 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
878 echo
879 fi
880 fi
881
756 #so now lets get rid of the patchno's we want to exclude 882 #so now lets get rid of the patchno's we want to exclude
757 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}" 883 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
758 for i in ${UNIPATCH_DROP}; do 884 for i in ${UNIPATCH_DROP}; do
759 ebegin "Excluding Patch #${i}" 885 ebegin "Excluding Patch #${i}"
760 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done 886 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
773 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi 899 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
774 900
775 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 901 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
776 while [ ${PATCH_DEPTH} -lt 5 ]; do 902 while [ ${PATCH_DEPTH} -lt 5 ]; do
777 echo "Attempting Dry-run:" >> ${STDERR_T} 903 echo "Attempting Dry-run:" >> ${STDERR_T}
778 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 904 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
779 echo "=======================================================" >> ${STDERR_T} 905 echo "=======================================================" >> ${STDERR_T}
780 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then 906 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
781 echo "Attempting patch:" > ${STDERR_T} 907 echo "Attempting patch:" > ${STDERR_T}
782 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 908 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
783 echo "=======================================================" >> ${STDERR_T} 909 echo "=======================================================" >> ${STDERR_T}
784 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then 910 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
785 eend 0 911 eend 0
786 rm ${STDERR_T} 912 rm ${STDERR_T}
787 break 913 break
788 else 914 else
789 eend 1 915 eend 1
807 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite, 933 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
808 # which is why I'm not taking too much time over this. 934 # which is why I'm not taking too much time over this.
809 local tmp 935 local tmp
810 for i in ${UNIPATCH_DOCS}; do 936 for i in ${UNIPATCH_DOCS}; do
811 tmp="${tmp} ${i//*\/}" 937 tmp="${tmp} ${i//*\/}"
812 cp -f ${i} ${T}/ 938 cp -f ${i} "${T}"/
813 done 939 done
814 UNIPATCH_DOCS="${tmp}" 940 UNIPATCH_DOCS="${tmp}"
815 941
816 # clean up KPATCH_DIR's - fixes bug #53610 942 # clean up KPATCH_DIR's - fixes bug #53610
817 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done 943 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
818 944
819 LC_ALL="${myLC_ALL}" 945 LC_ALL="${myLC_ALL}"
820 LANG="${myLANG}" 946 LANG="${myLANG}"
947 eval ${extglob_bak}
821} 948}
822 949
823# getfilevar accepts 2 vars as follows: 950# getfilevar accepts 2 vars as follows:
824# getfilevar <VARIABLE> <CONFIGFILE> 951# getfilevar <VARIABLE> <CONFIGFILE>
825# pulled from linux-info 952# pulled from linux-info
937 return 0 1064 return 0
938} 1065}
939 1066
940headers___fix() { 1067headers___fix() {
941 # Voodoo to partially fix broken upstream headers. 1068 # Voodoo to partially fix broken upstream headers.
942 # Issues with this function should go to plasmaroo. 1069 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
943 sed -i \ 1070 sed -i \
944 -e "s/\([ "$'\t'"]\)\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/\1__\2\3\4/g;" \ 1071 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
945 -e 's/ \(u\|s\)\(8\|16\|32\|64\)$/ __\1\2/g' \ 1072 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
946 -e 's/\([(, ]\)\(u\|s\)64\([, )]\)/\1__\264\3/g' \ 1073 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
947 -e "s/^\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/__\1\2\3/g;" \ 1074 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
948 -e "s/ inline / __inline__ /g" \ 1075 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
949 "$@" 1076 "$@"
950} 1077}
951 1078
952# common functions 1079# common functions
953#============================================================== 1080#==============================================================
954kernel-2_src_unpack() { 1081kernel-2_src_unpack() {
955 universal_unpack 1082 universal_unpack
1083 debug-print "Doing unipatch"
956 1084
957 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \ 1085 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
958 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}" 1086 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1087
1088 debug-print "Doing premake"
959 1089
960 # allow ebuilds to massage the source tree after patching but before 1090 # allow ebuilds to massage the source tree after patching but before
961 # we run misc `make` functions below 1091 # we run misc `make` functions below
962 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake 1092 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
963 1093
1094 debug-print "Doing epatch_user"
1095 epatch_user
1096
1097 debug-print "Doing unpack_set_extraversion"
1098
964 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion 1099 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
965 unpack_fix_docbook
966 unpack_fix_install_path 1100 unpack_fix_install_path
967 1101
1102 # Setup xmakeopts and cd into sourcetree.
1103 env_setup_xmakeopts
1104 cd "${S}"
1105
1106 # We dont need a version.h for anything other than headers
1107 # at least, I should hope we dont. If this causes problems
1108 # take out the if/fi block and inform me please.
1109 # unpack_2_6 should now be 2.6.17 safe anyways
1110 if [[ ${ETYPE} == headers ]]; then
968 kernel_is 2 4 && unpack_2_4 1111 kernel_is 2 4 && unpack_2_4
969 kernel_is 2 6 && unpack_2_6 1112 kernel_is 2 6 && unpack_2_6
1113 fi
1114
1115 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1116 cp "${DISTDIR}/${DEBLOB_A}" "${T}"
1117 chmod +x "${T}/${DEBLOB_A}"
1118 fi
970} 1119}
971 1120
972kernel-2_src_compile() { 1121kernel-2_src_compile() {
973 cd "${S}" 1122 cd "${S}"
974 [[ ${ETYPE} == headers ]] && compile_headers 1123 [[ ${ETYPE} == headers ]] && compile_headers
975 [[ ${ETYPE} == sources ]] && \ 1124
976 use doc && compile_manpages 1125 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1126 echo ">>> Running deblob script ..."
1127 sh "${T}/${DEBLOB_A}" --force || \
1128 die "Deblob script failed to run!!!"
1129 fi
977} 1130}
978 1131
979kernel-2_pkg_preinst() { 1132kernel-2_pkg_preinst() {
980 [[ ${ETYPE} == headers ]] && preinst_headers 1133 [[ ${ETYPE} == headers ]] && preinst_headers
981} 1134}
990 [[ ${ETYPE} == headers ]] && postinst_headers 1143 [[ ${ETYPE} == headers ]] && postinst_headers
991 [[ ${ETYPE} == sources ]] && postinst_sources 1144 [[ ${ETYPE} == sources ]] && postinst_sources
992} 1145}
993 1146
994kernel-2_pkg_setup() { 1147kernel-2_pkg_setup() {
1148 if kernel_is 2 4; then
1149 if [ "$( gcc-major-version )" -eq "4" ] ; then
1150 echo
1151 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1152 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1153 ewarn "newer kernel that supports gcc-4."
1154 echo
1155 ewarn "Also be aware that bugreports about gcc-4 not working"
1156 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1157 echo
1158 epause 10
1159 fi
1160 fi
1161
1162 ABI="${KERNEL_ABI}"
995 [[ ${ETYPE} == headers ]] && setup_headers 1163 [[ ${ETYPE} == headers ]] && setup_headers
996 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1164 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
997} 1165}

Legend:
Removed from v.1.159  
changed lines
  Added in v.1.231

  ViewVC Help
Powered by ViewVC 1.1.20